#!/usr/bin/perl
$ETCDIR = "/etc/dcbib";
$BINDIR = "/usr/bin";
# cgi.pl - CGI assistant routines
# Copyright (C) by TOYODA Eizi, 1999.  All rights reserved.
#
$rcsid .= '$Id: cgi.pl,v 1.4 2000/09/21 16:58:53 takepiro Exp $';
#

	# ۥ̾ (FQDN) ֤
	# Debian GNU/Linux ƥ DNS ꤬Ԥ줿֤ͤƤʤ
sub Hostname () {
	local($hostname) = '/bin/hostname';
	return 'localhost' unless -x $hostname;
	$hostname = `$hostname -f`;
	chop $hostname;
	return $hostname;
}

#
# HTML 뤿Υ֥롼.
# ̾ print ǻϤޤΤϴŪ print ʸηǤ,
# ɸ (select ѹǽ)  HTML ΰϤ.
#

	# ʸ HTML ʸǤ褦ѷ.
	# 
	#	$line	Ǥդʸ
	# ֵ
	#	HTML üʰ̣ʸ & < > " Ѵ
	# Х
	#	\0  & ȺƱƤޤ.
sub HTMLEscape {
	local($line) = @_;
	$line =~ s/&/\0/g;
	$line =~ s/</\&lt;/g;
	$line =~ s/>/\&gt;/g;
	$line =~ s/"/\&quot;/g;
	$line =~ s/\0/\&amp;/g;
	return $line;
}

	# HTTP إå HTML Ƭ롣
	# 
	#	$title		ʸΥȥ
	#	$color		(ά) 
sub printHtmlOpening {
	local($title, $color) = @_;
	$color = "#CCEECC" unless $color;
	local($hostname) = &Hostname();
	print <<"END";
Content-type: text/html;charset='euc-jp'

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY BGCOLOR="$color">
<A HREF="/doc/dcbib/dcbib.htm">dcbib</a>
(<A HREF='/'>$hostname</a> ˤư)
<H1 ALIGN="center">$title</H1>
END
}

	# &printTextField ƥȥեɤ礭
	# ѤĤϤȤѤƤ.
$printTextFieldLength = 60;
$printTextFieldHeight = 10;	# ƥȥꥢǤ

	# Ͽե <TABLE> ΤʤǤҤȤĤΥƥȥեɤ
	# Ϥ׵᤹ <TR> .
	#
	# 
	#   $fieldname		̾
	#   $description	
	#   $default		ά (ʤƤ褤)
	#			%card{$fieldname} ¸ߤФ줬ͥ
	# ۤΰ
	#   %card
sub printTextField {
	local($fieldname, $description, $default) = @_;
	local($size) = $printTextFieldLength;
	local($defaultvalue) = $card{$fieldname} || $default;
	if ($fieldname eq "token") {
		#
		# ̾Τ token ξϥѥˤ
		# ޤͤ϶ˤ
		print <<"END";
 <TR>
 <TD NOWRAP ALIGN="right">$description</TD>
 <TD NOWRAP>
 <INPUT TYPE="PASSWORD" NAME="$fieldname" SIZE="$size">
 </TD>
 </TR>
END
	} elsif ($default =~ /\n/) {
		#
		# άͤ˲ԤޤޤƤХƥȥե
		# (Ǥ)
		#
		print <<"END";
 <TR>
 <TD NOWRAP ALIGN="right">$description</TD>
 <TD NOWRAP>
 <TEXTAREA NAME="$fieldname" COLS="$size" ROWS=$printTextFieldHeight>
$defaultvalue
 </TEXTAREA>
 </TD>
 </TR>
END
	} else {
		print <<"END";
 <TR>
 <TD NOWRAP ALIGN="right">$description</TD>
 <TD NOWRAP>
 <INPUT TYPE="text" NAME="$fieldname" SIZE="$size" VALUE="$defaultvalue">
 </TD>
 </TR>
END
	}
}

	# Ͽե <TABLE> ΤʤꥹȤΥ饸ܥä
	# Ϥ׵᤹ <TR> .
	# άͤ "\n" ޤޤƤʣԥץĤ.
	# 
	#   $fieldname		̾
	#   $description	
	#   $default		ǥե
	#   @ValueDescriptionList
	#	ǽͤΥꥹ. ƹब "\t" ޤǤ
	#	θɽ.
sub printRadioButton {
	local($fieldname, $description, $default, @ValueDescriptionList) = @_;
	print <<"END";
<TR>
<TD NOWRAP ALIGN="right">$description</TD>
<TD>
ʲΥꥹȤǤ:<BR>
<TABLE BORDER><TR><TD><!-- ȤĤä -->
END
	local($vdpair, $value, $desc, $checked);
	foreach $vdpair (@ValueDescriptionList) {
		print "<BR>" if $value;
		($value, $desc) = split(/\t/, $vdpair, 2);
		$checked = ($value eq $default) ? "CHECKED" : "";
		$desc = $value unless $desc;
		print "<INPUT TYPE=RADIO NAME='$fieldname' ",
		"VALUE='$value' $checked>$desc\n";
	}
	print <<"END";
</TD></TR></TABLE><!-- ȤĤä -->
</TD>
END
}

	# HTML ʸκ
	# 
	#	$title		ʸΥȥ
sub printHtmlClosing {
	local($title) = @_;
	print "<hr>\n";
	print "<a href=\"", &CGISelfName, "\">$title ˤɤ</a><br>\n"
		if &FormSubmitted();
	print <<"END";
<div align="right">
: <i><a href=mailto:$MAILADDR>$MAILADDR</a></i>
<br>$rcsid
</div>
</body>
</html>
END
}

#
# CGI (Common Gateway Interface) طΥ֥롼
#

	# 桼󥫡ɤɤ߹Ϣ %param 
	# å˥åȤ٤ʸ.
sub HashToCookie {
	local(%param) = @_;
	local(@pairs) = ();
	local($key, $value);
	foreach $key (sort(keys(%param))) {
		$value = $param{$key};
		push(@pairs, &URLEncode($key) . ":" . &URLEncode($value));
	}
	join('&', @pairs);
}

	# CGI ץȤƤӽФ, ʬȤΥե֤̾.
	# ϱΥ󥯤ȤƻȤ.
sub CGISelfName {
	$ENV{'SCRIPT_NAME'};
}

	# CGI ǡĹ֤.
sub CGIDataLength {
	$ENV{'CONTENT_LENGTH'};
}

	# 桼 Submit ܥ򲡤翿
	# Ǥʤ絶֤롣
	# CGI ץȥ뻲.
sub FormSubmitted() {
	return ($ENV{"CONTENT_LENGTH"} > 0);
}

	# CGI ǡɤ߹ϢȤ֤.
	# ǡͿƤʤ϶ꥹȤ֤.
sub getCGIData {
	local(%card);
	local($data, $key, $value);
	require 'jcode.pl';

	return () unless &FormSubmitted();
	read(STDIN, $alldata, &CGIDataLength);
	foreach $data (split(/&/, $alldata)) {
		($key, $value) = split(/=/, $data);
		$value =~ tr/+/ /;
		$value = &URLDecode($value);
		&jcode'convert(*value, "euc");
		$card{$key} = $value;
	}
	%card;
}

	#  $x  URL 󥳡ɤ֤.
	# åˤʸƤν򤷤ʤƤϤʤʤ
	# CGI ץȥ뻲.
sub URLEncode {
    local($x) = @_;
    $x =~ s/([&:;=%\x00-\x21])/sprintf("%%%02X",unpack("C",$1))/ge;
    return $x;
}
 
	# URL 󥳡ɤ줿ʸ ( $x) ɤ֤.
	# åʸƤν򤷤ʤƤϤʤʤ
	# CGI ץȥ뻲.
sub URLDecode {
    local($x) = @_;
    $x =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C",hex($1))/ge;
    return $x;
}

0;
# addcgi.pl - CGI main program for dcbib
# Copyright (C) TOYODA Eizi, 1999.  
#               TAKEHIRO Shin-ichi, 2000. 
#               All rights reserved.

#
$rcsid .= '$Id: addcgi.pl,v 1.14 2000/09/25 06:40:49 takepiro Exp $';
#

require 'open3.pl';

$TITLE = "dcbib ʸϿΥڡ";
$MAILADDR = "bunken\@gfd-dennou.org";
$BINDIR = '/usr/bin' unless $BINDIR;
$ETCDIR = '/etc' unless $ETCDIR;
$CONFIGFILE = "$ETCDIR/dcbib.conf";

&emlOpenFile($CONFIGFILE);
%CONFIG = &emlReadHeader();

if (not &FormSubmitted()) {
	&SyokiGamen();
	exit 0;
}

%card = &getCGIData();

if ( $card{'phase'} eq 'NEW' ) {
	if (not &EmailCheck($card{'from'})) {
		&SyokiGamen("Żҥ᡼륢ɥ쥹ϤƤ.");
		exit 0;
        }
	&printHtmlOpening($TITLE);
	&NyuuryokuGamen();
	&printHtmlClosing($TITLE);

} elsif ( $card{'phase'} eq 'MODIFY') {
	if (not &EmailCheck($card{'from'})) {
	    &SyokiGamen("Żҥ᡼륢ɥ쥹ϤƤ.");
	    exit 0;
        }
        $card{'origfile'} = &RelativetoFullpathFileName($card{'origfile'});
        if ( $card{'origfile'} eq '') {
	    &SyokiGamen("ե̾ޤ. ");
	    exit 0;
        } elsif ( !-f $card{'origfile'}) {
	    &SyokiGamen("ե뤬¸ߤޤ. ");
	    exit 0;
        } else {
	    &emlOpenFile($card{'origfile'});
	    %cardfile = &emlRead();
	    foreach $key ( keys %cardfile ) { 
		$card{$key} = $cardfile{$key} unless $key eq 'from'; 
	    }
	}
        &printHtmlOpening($TITLE);
	&NyuuryokuGamen();
        &printHtmlClosing($TITLE);

} elsif ( $card{'phase'} eq 'REMOVE') {
	if (not &EmailCheck($card{'from'})) {
	    &SyokiGamen("Żҥ᡼륢ɥ쥹ϤƤ.");
	    exit 0;
        }
        $card{'origfile'} = &RelativetoFullpathFileName($card{'origfile'});
        if ( $card{'origfile'} eq '') {
	    &SyokiGamen("ե̾ޤ. ");
	    exit 0;
        } elsif ( !-f $card{'origfile'}) {
	    &SyokiGamen("ե뤬¸ߤޤ. ");
	    exit 0;
        } else {
	    &printHtmlOpening($TITLE);
	    &SakujoGamen();
	    &printHtmlClosing($TITLE);
        }

} elsif ( $card{'phase'} eq 'DO REMOVE') {
        &SakujoKekkaGamen();

} elsif ($card{'phase'} eq 'check') {
	&CheckGamen();

} else {
	&KekkaGamen();
}

exit 0;


sub SyokiGamen {
	local($message) = @_;
	&printHtmlOpening($TITLE);
	if ($message) {
		print "<HR>", $message;
	}
	print <<EOF;
<HR>
<FORM METHOD="POST" ACTION="$ENV{'SCRIPT_NAME'}">

ǽˤʤŻҥ᡼륢ɥ쥹ϤƤ:
 <INPUT TYPE="text" NAME="from" SIZE=60><P>
<P>
ǡοϿ뤤Ͻ˱ưʲ򤷤Ƥ. 

<OL>
<LI>
 ǡϿ : Ͽʸμ򤷤
 <INPUT TYPE="submit" NAME="phase" VALUE="NEW">
 ܥ򲡤Ƥ:

 <DL>
 <DT><INPUT TYPE="radio" NAME="cardtype" VALUE="article" CHECKED>article
 <DD>ʸ˷Ǻܤ줿ҤȤĤǤ
 <DT><INPUT TYPE="radio" NAME="cardtype" VALUE="book">book
 <DD>ΤǤ
 <DT><INPUT TYPE="radio" NAME="cardtype" VALUE="inbook">inbook
 <DD>ҤΰǤ
 <DT><INPUT TYPE="radio" NAME="cardtype" VALUE="misc">misc
 <DD>嵭ƤˤƤϤޤʤΤǤ
 </DL>

<LI>
 ǡϿ : ȤʤʸǡΥե̾򲼤Ϥ
 <INPUT TYPE="submit" NAME="phase" VALUE="MODIFY">
 ܥ򲡤Ƥ.  <P>

<LI>
 ǡ : ʸǡΥե̾򲼤Ϥ
 <INPUT TYPE="submit" NAME="phase" VALUE="REMOVE">
 ܥ򲡤Ƥ. եȤǧǤޤ. <P>

 ե̾ <INPUT TYPE="text" NAME="origfile" SIZE=30> 
 <INPUT TYPE="submit" NAME="phase" VALUE="MODIFY">
 <INPUT TYPE="submit" NAME="phase" VALUE="REMOVE"><P>
 ե̾η "$CONFIG{'cardpath'}" Ǥ. 
  %y, %i, %n Ϥ줾, year(), initial(a-z 1 ʸ), number()
 ɽƤޤ. 

</OL>
</FORM>
EOF
	&printHtmlClosing($TITLE);
}

sub NyuuryokuGamen {
	$lang = $card{'lang'} || 'ja';
	$user = $card{'from'};
	$user =~ s/@.*//;

        &warn("$field not available.")
	    unless &existsin($card{'cardtype'},&cardTypeList);

# ǽΤ
	print <<EOF;
	<HR>
	<FORM METHOD="POST" ACTION="$ENV{'SCRIPT_NAME'}">
	<P>
	Ͽ $card{'cardtype'} ʸϿޤ
	ʣϿʤɤ
	<A HREF="/arch/bunken/search.htm">
	</a>ƤϿ뤳Ȥ򤪴ᤷޤ
	 
	ϤѤ <INPUT TYPE="submit" NAME="phase" VALUE="check">
	ܥ򲡤ϤǡåƤ
	ٹ𤬤ʤʤä <INPUT TYPE="submit" NAME="phase" VALUE="submit">
	ܥ򲡤ƥǡϿƤ
	<P>
	<TABLE BORDER=0>
EOF

# ɬܹ
	$hr = "" x 40;
	@needed = &requiredFields($card{'cardtype'});
	$neededfields = join(', ',@needed);
	@needed = &ExpandSlash(@needed);
        foreach $key (@needed) {
	    $card{$key}=&cardTypeFieldDefault($key) if !exists $card{$key};
	}

	print <<EOF;
	<TR><TD>ɬܹ:</TD><TD>$hr</TD></TR>
	<TR><TD></TD><TD>ʲ $neededfields ɬϤƤ.  / Ƕڤ줿ܤ, ʤȤ⤽Τɤ줫ĤιܤϤнʬǤ. </TD>
        <TR><TD></TD></TR>
	<TR>
	 <TD NOWRAP ALIGN="right">
	  <INPUT TYPE="hidden" NAME="cardtype" VALUE="$card{'cardtype'}">
	  cardtype </TD>
	 <TD> $card{'cardtype'}</TD>
	</TR>

        <TR><TD></TD><TD>Ͽ</TD></TR><TR><TD></TD></TR>
	<TR>
	 <TD NOWRAP ALIGN="right">
	    <INPUT TYPE="hidden" NAME="from" VALUE="$card{'from'}">From </TD>
	 <TD> $card{'from'}</TD>
 	</TR>
        <TR><TD></TD><TD></TD></TR><TR><TD></TD></TR>
EOF
	&printTextFields(@needed);

# Ǥչ
	@optional = &optionFields($card{'cardtype'});
	foreach $key (@optional) {
	    $card{$key}=&cardTypeFieldDefault($key) if !exists $card{$key};
	}

	print "<TR><TD>Ǥչ:</TD><TD>$hr</TD></TR>\n";
        print "<TR><TD></TD></TR>\n";
	&printTextFields(@optional);

# פʹ
	print "<INPUT TYPE=hidden NAME=origfile VALUE=$card{'origfile'}>\n"
	    if exists $card{'origfile'};

        $keylist = join(' ', keys(%card)).' ';
	foreach $key ( ('lang','phase','cardtype','from','origfile') ) { $keylist =~ s/$key //; }
	foreach $key ( @needed   ) { $keylist =~ s/$key //; }
	foreach $key ( @optional ) { $keylist =~ s/$key //; }
        @unavailable = split(' ', $keylist);
        if ( scalar(@unavailable) > 0 ) {
	    print "<TR><TD>Ŭ:</TD><TD>$hr</TD></TR>\n";
	    print "<TR><TD></TD><TD>Ƥˤйܤޤ. </TD></TR>\n";
	    &printTextFields(@unavailable);
	}

	print <<EOF;
	<TR><TD></TD><TD>$hr</TD></TR>
	<TR><TD></TD><TD>
	    <INPUT TYPE="submit" NAME="phase" VALUE="check">
	    <INPUT TYPE="submit" NAME="phase" VALUE="submit">
 	    <INPUT TYPE="reset" VALUE="reset">
	</TD></TR>
</TABLE>

</FORM>
EOF
}

sub CheckGamen {
        ($exitcode, $pid, @result) = &processCard;
	&printHtmlOpening($TITLE);
	print "<HR>\n";
	if ($exitcode == 0) {
	    print "<H2>ϥǡˤϸϤޤ.</H2>\n";
	} else {
	    print "<H2>ϥǡˤϸ꤬ޤ.</H2>\n";
	    print "<P>\n";
	    print "ǡ٥åƤ\n";
	    print "<P>\n";
	}
	print join("<BR>\n", @result);

	&NyuuryokuGamen();
	&printHtmlClosing($TITLE);
}

sub KekkaGamen {
        ($exitcode, $pid, @result) = &processCard;
	&printHtmlOpening($TITLE);
	print "<HR>\n";
	if ($exitcode == 0) {
		$result = "";
	} elsif ($exitcode == 1) {
		$result = "(ٹϤΤ) ";
	} else {
		$result = "";
	}
	print "<H2>${result}ޤ</H2>\n";
	print join("<BR>\n", @result);
	print <<EOF;
<HR>
ƤϰʲΤȤǤ
<DL>
EOF
	foreach $key (keys %card) {
		print "<DT>$key:<DD>$card{$key}\n";
	}
	print "</DL>\n";

	if ( exists $card{'origfile'} ) {
	    print <<EOF
	    <HR>
	    <FORM METHOD="POST" ACTION="$ENV{'SCRIPT_NAME'}">
	      <INPUT TYPE=hidden NAME=origfile VALUE=$card{'origfile'}>
	      <INPUT TYPE=hidden NAME=from VALUE=$card{'from'}>
	      Υǡե  $card{'origfile'} ޤ?
	      ʤ
	      <INPUT TYPE="submit" NAME="phase" VALUE="REMOVE">
	      ܥ򲡤Ƥ. 
	      եȤǧǤޤ. <BR>
	    </FORM>
EOF
        }
	&printHtmlClosing($TITLE);
}

sub processCard {
	local($READ, $WRITE, $pid, @result, $exitcode);
	local($origfile)='';
        $READ = "READ";
        $WRITE = "WRITE";
	if ( $card{'phase'} eq 'check' ) {
	    $pid = &open3($WRITE, $READ, '', "$BINDIR/dcbib-add -t");
	} else {
	    $pid = &open3($WRITE, $READ, '', "$BINDIR/dcbib-add");
	}
	$phase = $card{'phase'};
	delete $card{'phase'};
	if (exists $card{'origfile'}){
	    $origfile = $card{'origfile'} ;
	    delete $card{'origfile'};
	}

        &writeCardStream($WRITE, %card);
        close($WRITE);
        @result = <$READ>;
        (waitpid($pid, 0) >= 0)
                || (@result = ("$?: invocation failed."));
        $exitcode = (($? >> 8) & 255);

	if ($origfile ne ''){
	    $card{'origfile'} = $origfile;
	}
	$card{'phase'} = $phase;
        ($exitcode, $pid, @result)
}

sub writeCardStream {
	local($WRITE, %card) = @_;
	&emlWrite($WRITE, %card);
}

sub SakujoGamen {
	print "<HR>\n";
        print "<H2>ǡ: $card{'origfile'} </H2><P>\n";	

	print <<EOF;
	<FORM METHOD="POST" ACTION="$ENV{'SCRIPT_NAME'}">
	<INPUT TYPE=hidden NAME=origfile VALUE=$card{'origfile'}>
	ɤʤ, 
        <INPUT TYPE="submit" NAME="phase" VALUE="DO REMOVE">
	ܥ򲡤Ƥ. <BR>
	</FORM>
EOF
	print "<HR><P>\n";
        open(FILE,"<".$card{'origfile'});
        print $_,"<BR>\n" while (<FILE>);
}

sub SakujoKekkaGamen {
        local($command) = "$BINDIR/dcbib-remove $card{'origfile'}";
        $exitcode = system $command;

	&printHtmlOpening($TITLE);
	print "<HR>\n";
	if ($exitcode == 0) {
		$result = "";
	} else {
		$result = "";
        }
	print <<EOF;
	<H2>$resultޤ. </H2>
        <HR>
	¹Ԥ줿ޥ: $command
EOF
	&printHtmlClosing($TITLE);
}

sub EmailCheck {
	local($email) = @_;
	return 0 unless $email;
	return ($email =~ /.@./);
}

sub date {
	local($sec, $min, $hour, $day, $mon, $year) = gmtime(time);
	return sprintf("%04d-%02d-%02d", $year+1900, $mon+1, $day);
}

sub printTextFields {
    local(@fieldlist)=@_;
	foreach $key (@fieldlist) {
#	    &printTextField($key, &cardTypeDescription($key), $card{$key});
	    &printTextField($key, $key, $card{$key});
	    $setsumei = "<TR><TD></TD><TD>".&cardTypeDescription($key) ." : " 
	       . &cardTypeLongDescription($key)."</TD></TR>";
	    print $setsumei,"\n";
	    print "<TR><TD></TD></TR>\n";
	}
}
# fncreat.pl: filename generation routine for dcbib-add(1).
# $Id: fncreat.pl,v 1.5 2000/09/21 16:58:53 takepiro Exp $
# Copyright (c) TOYODA Eizi, 1998.  
#               TAKEHIRO Shin-ichi, 2000. 
#               All rights reserved.
# see COPYING.TXT for terms of license.

# assumption:
# * %CONFIG has information from configfile (e.g. /etc/dcbib.conf).
# * %CARD has information from bib card and tested with &testCard.

sub generateFileName {
	# assumes ending with slash
	local($pat) = $CONFIG{"basedir"};
	$pat =~ s/\/+$//;
	$pat .= "/";
	$pat .= $CONFIG{"cardpath"};
	$pat =~ s/%i/&gfn_initial/ge;
	$pat =~ s/%y/&gfn_year/ge;

	# unique number generator
	if ($pat =~ /%n/) {
		local($number) = 1;
		for (;; $number++) {
			$fnam = $pat;
			$fnam =~ s/%n/$number/g;
			$fnambak = &RemovedFileName($fnam); 
			#last unless (-e $fnam);
			last if (!-e $fnam && !-e $fnambak);
		} 
	} else {
		# Are you sure?  This will overwrite existing same name.
		&warn("cardpath has no %n");
		$fnam = $pat;
	}

	$fnam;
}


sub gfn_year {
	$CARD{"year"};
}


# get initial character of author's family name
sub gfn_initial {
	local($author) = $CARD{"author"};
	$author = $CARD{"editor"} unless $author;
	$author =~ s/^\n+//;
	# if unknown
	return "u" unless $author;
	if ($author =~ /,/) {
		$author =~ s/^\s*//;
	} else {
		# getting last word
		$author =~ s/\s*$//; 
		$author =~ s/^.*[ .]+//; 
	}
	# get initial character
	local($ini) = substr($author, 0, 1);
	return 'u' unless ($ini =~ /^[A-Za-z]/);
	$ini =~ tr/A-Z/a-z/;
	$ini;
}

# backup (removed) file name
sub RemovedFileName {
    local($origfile)=@_;
    $origfile ."~";      # tilde is added
}

# Generate full path filename from 'basedir' and 'cardpath' fields 
# of CONFIG file. Portion of the input fitted to 'cardpath' pattern 
# and connected with the 'basedir'. 
# Null file name is returned if the input does not match the patter. 
#
sub RelativetoFullpathFileName {
    local($filename) = @_;
    $regexp = $CONFIG{'cardpath'};
    $regexp =~ s/%y/[0-9x][0-9x][0-9x][0-9x]/g;   # year
    $regexp =~ s/%i/[a-z]/g;                      # initial
    $regexp =~ s/%n/[0-9]+/g;                     # number
    $filename =~ m"($regexp)";

    return '' if $1 eq '';

    $CONFIG{'basedir'} .'/' . $1;
}
# error.pl: error handler
# $Id: error.pl,v 1.1.1.1 2000/03/18 06:54:10 odakker Exp $
# Copyright (c) TOYODA Eizi, 1998.  All rights reserved.
# see COPYING.TXT for terms of license.

sub die {
	local($msg) = @_;
	print STDERR "ERROR: $msg\n";
	exit 2;
}

sub warn {
	local($msg) = @_;
	print STDERR "WARNING: $msg\n";
	$exit = 1;
}

sub okay {
	local($msg) = join(' ', @_);
	print STDERR "OK: $msg\n";
}

sub exit {
	exit $exit;
}
# RFC-822-like file reading/writing module
# $Id: rfc822.pl,v 1.4 2000/09/23 15:17:51 takepiro Exp $
# Copyright (c) TOYODA Eizi, 1998.  
#               TAKEHIRO Shin-ichi, 2000. 
#               All rights reserved.
# see COPYING.TXT for terms of license.

sub emlOpenFile {
	local($file) = @_;
	&open_r($file) || &die("cannot open <$file>");
	&emlSetFile($file);
}

sub emlSetFile {
	($emlFile) = @_;
}

sub emlReadLine {
	&readline($emlFile);
}

# -- emlReadHeader() ---
#
# Reads RFC 822 headers from $inputfile and returns hash with which
# $returned_hash{$field_name} == $filed_value,
# where $field_name is lowercased  filed name.
# If $field_value contains '\n', it means that the header
# $field_name appeared more than once.
# Undefined return value means there is a format error.

sub emlReadHeader {
	local(%headers) = ();
	local($name, $val) = ("", "");

	while ($_ = &emlReadLine) {
		s/\r?\n$//;
		last if /^$/;    # ԤޤǤإå
		if (!/^\s/) {
			next if /^From /;
			if (!/^([-A-Za-z0-9]*)(:)\s*(.*)/) {
				&warn("broken header <$_> in $emlFile");
				return undef;
			}
			($name = $1) =~ tr/A-Z/a-z/;
			($val = $3) =~ s/[\t\r]/ /g;
			if (defined $headers{$name}) {
				# Ʊ̾ʣإåϲԶ
				$headers{$name} .= "\n$val";
			} else {
				$headers{$name} = $val;
			}
		} else {
			s/[\t\r]/ /g;
			# ³Ԥϥֶ
			s/^ */\t/;
			$headers{$name} .= $_;
		}
	}
	%headers;
}

sub emlWriteHeader {
	local($outfnam, %headers) = @_;
	local($fieldname, @values, $value, $folded);

	foreach $fieldname (keys %headers) {
		local(@values) = split(/\n/, $headers{$fieldname});
		foreach $value (@values) {
			next if $value =~ /^[ \n\t]*$/;
			$folded = $value;
			$folded =~ s/\t/\n\t/g;
			print $outfnam "$fieldname: $value\n";
		    }
	    }
    }

# -- emlRead() ---
#
#

sub emlRead {
    local(%card) = ();
    %card = &emlReadHeader();        # إåɤ߹
    while ($_ = &emlReadLine) {      # ʸɤ߹
	$card{'mainpart'} .= $_;    #   إå mainpart ɲ
    }
    %card;
}

sub emlWrite {
    local($outfnam, %card) = @_;

    local($mainpart) = $card{'mainpart'};
    delete $card{'mainpart'};

    &emlWriteHeader($outfnam, %card);   # إå
    $mainpart =~ s/\r?\n/\n/g;          #  ^M 
    print $outfnam "\n";                # ʸȤζڤ
    print $outfnam $mainpart;           # ʸ
    print $outfnam "\n";                # Ǹϲ
}
# misc. file io concerned subroutines
# $Id: fio.pl,v 1.1.1.1 2000/03/18 06:54:10 odakker Exp $
# Copyright (c) TOYODA Eizi, 1998.  All rights reserved.
# see COPYING.TXT for terms of license.

	# create file to write. make directory if necessary.
sub creat {
	local($fnam) = @_;
	local($parent) = $fnam;
	&CheckUmask;
	&mkdir($parent) if ($parent =~ s/\/[^\/]+$//);
	open($fnam, ">$fnam") || &die("creat $fnam");
	$fnam;
}

sub CheckUmask {
	return unless ((umask) & 0660);
	local($umask) = (umask) & ~0660;
	&warn(sprintf("warning: umask set to %04lo\n", $umask));
	umask $umask;
}

sub mkdir {
	local($dnam) = @_;
	return if (-d $dnam);
	local($parent) = $dnam;
	if ($parent =~ s/\/[^\/]+$//) {
		&mkdir($parent);
	} else {
		return;
	}
	mkdir($dnam, 0777) || &die("mkdir $dnam");
}

# check.pl - ʸɤƤΥå
# $Id: check.pl,v 1.3 2000/09/21 16:58:53 takepiro Exp $
# Copyright (c) TOYODA Eizi, 1998.  All rights reserved.
#               TAKEHIRO Shin-ichi, 2000. 
# see COPYING.TXT for terms of license.
#
# :
#	ƥإåƤ %HEADER ˳ǼƤ롣

sub checkCard {
	local(*HEADER) = @_;

    # Cardtype Υå
	if ( $checkmode ) {
	    &warn("$HEADER{'cardtype'} not available.")
		unless &existsin($HEADER{'cardtype'},&cardTypeList);
	}
	else{
	    &die("$HEADER{'cardtype'} not available.")
		unless &existsin($HEADER{'cardtype'},&cardTypeList);
	}

    # ̾Υå
	foreach $field (keys %HEADER) {
	    &warn("$field not available.")
		unless &existsin($field,
		    &ExpandSlash(&availableFields($HEADER{'cardtype'})));
	}

    # ɬܹܤ¸ߡƥå
	foreach $fields (&requiredFields($HEADER{'cardtype'})) {
	    $ok=0;
	    foreach $field (&ExpandSlash($fields)) { 
		if (exists $HEADER{$field}) {
		    $ok=1;
		    $HEADER{$field} 
		      = &checkFieldContent($field,$HEADER{$field});
		}
	    }
	    if ( $checkmode ){
		&warn("$fields required.") unless $ok;
	    }
	    else {
		&die("$fields required.") unless $ok;
	    }
	}
    # Ǥչܤ¸ߡƥå
	foreach $field (&optionFields($HEADER{'cardtype'})) {
	    $HEADER{$field} 
	    = &checkFieldContent($field,$HEADER{$field});
	}
}
    # 
    # ꥹͤ¸ߤ뤫å
    #
sub existsin {
    local($checkval,@list)=@_;
    foreach $val (@list) {
	if ($checkval eq $val) { return 1; }
    }
    return 0;
}
    # 
    # /(å)ޤե̾ꥹȤŸƥꥹȤ.
    #
sub ExpandSlash() {
    local(@input)=@_;
    local(@output)=();

    foreach $field ( @input ) {
	local(@expandedlist) = split(/\//,$field);
	push(@output,@expandedlist);
    }
    @output;
}
# card.pl - ʸɤΥեɤ˴ؤ
# $Id: card.pl,v 1.13 2000/09/25 10:44:39 takepiro Exp $
# Copyright (c) TOYODA Eizi, 1998.  All rights reserved.
# see COPYING.TXT for terms of license.
#
#  : cardtype, From, mainpart ͽ
#
sub cardTypeHash {
 %CARDTYPE = (
	'article'	=> 'ʪޤϳؽѻε',
	'book'		=> ' (ǼԤΤʤ)',
	'inbook'	=> 'Ҥΰ (ͭɽ⤿ʤ)',
	'misc'	        => 'ʪ, ؽѻ, Ƥ°ʤ',
 );
 %REQUIREDFIELD = (
	'article'	=> 'author/author-ja title/title-ja journal year',
	'book'		=> 'author/editor/author-ja/editor-ja title/title-ja publisher year',
	'inbook'	=> 'author/editor/author-ja/editor-ja title/title-ja chapter/pages publisher year',
	'misc'	        => 'remark',
 );
 %OPTIONFIELD = (
	'article'	=> 'volume number pages month url remark copyholder id keyword keyword-ja history mainpart',
	'book'		=> 'volume series address edition month url remark copyholder id keyword keyword-ja history mainpart',
	'inbook'	=> 'volume series address edition month url remark copyholder id keyword keyword-ja history mainpart',
	'misc'	       => 'author editor author-ja editor-ja title title-ja year volume number series chapter pages publisher address edition month url copyholder id keyword keyword-ja history mainpart',
 );
 %FIELDDESCRIPTION = (
	'address'	=> 'ǼԤν',
	'author'	=> '',
	'author-ja'	=> '(ܸ)',
	'chapter'	=> 'ֹ',
	'edition'	=> 'Ҥǿ',
	'editor'	=> 'Խ',
	'editor-ja'	=> 'Խ(ܸ)',
	'journal'	=> 'ʪ̾',
	'month'		=> 'Ԥ줿',
	'number'	=> '',
	'pages'		=> 'ڡϰ',
	'publisher'	=> 'Ǽ',
	'series'	=> 'ҥ꡼ɽ',
	'title'		=> 'ɽ',
	'title-ja'	=> 'ɽ(ܸ)',
	'volume'	=> 'ֹ',
	'year'		=> 'ǯ',
	'url'	        => 'URL ',
	'remark'	=> 'Ÿ',
	'from'	        => 'ȯ',
	'copyholder'	=> 'ʸ',
	'history'	=> '',
        'id'	        => 'ʸֹ',
	'keyword'	=> '',
	'keyword-ja'	=> '(ܸ)',
	'mainpart'	=> 'ʸ',
 );
 %FIELDLONGDESCRIPTION = (
	'address'	=> '̾ʽǼҤʤԻ̾Ǥ褤. ',
	'author'	=> "ʣϲԤ뤫 \'/\' Ƕڤ. \n ̾̾ǤΤȤ˥ (',') . ",
	'author-ja'	=> 'ʣϲԤ뤫 \'/\' Ƕڤ. ',
	'chapter'	=> 'Τߤ򵭤',
	'editor'	=> "ʣϲԤ뤫 \'/\' Ƕڤ. \n ̾̾ǤΤȤ˥ (',') . ",
	'editor-ja'	=> 'ʣϲԤ뤫 \'/\' Ƕڤ. ',
	'journal'	=> '',
	'month'		=> '(̤ԤξϽ񤫤줿)',
	'number'	=> '',
	'pages'		=> '42--111 Τ褦˥ϥե2Ѥ',
	'publisher'	=> '',
	'series'	=> '',
	'title'		=> '',
	'title-ja'	=> '',
	'volume'	=> '',
	'year'		=> '4 ο. ̤ԤξϽ񤫤줿ǯ. ǯ 85 Τ褦άƤϤʤʤ.',
	'url'	        => '1 񸻤 Web ˤƸƤ.',
	'remark'	=> '̾νŸƤϤޤʤ˵.',
	'from'	        => '᡼륢ɥ쥹. ʣ¸ߤϲԤ뤫 \'/\' Ƕڤ. ',
	'copyholder'	=> '᡼륢ɥ쥹. ʣ¸ߤϲԤ뤫 \'/\' Ƕڤ. ',
	'history'	=> '; ̾; ᡼륢ɥ쥹פηǵ. <br>:2000/08/29; Hayashi Yoshi-Yuki; shosuke@gfd-dennou.org <br>ʣιܤ¸ߤϲԤ뤫 \'/\' Ƕڤ.',
	'id'	        => '֥᡼륢ɥ쥹; ֹפηǵ. <br>: shosuke@gfd-dennou.org; 123<br>ʣΰۤʤ᡼륢ɥ쥹¸ߤϲԤ뤫 \'/\' Ƕڤ.',
	'keyword'	=> '֥᡼륢ɥ쥹; ɡפηǵ. <br>: shosuke@gfd-dennou.org; Rossby wave, rotation, wave momentum<br>ʣΰۤʤ᡼륢ɥ쥹¸ߤϲԤ뤫 \'/\' Ƕڤ.',
	'keyword-ja'	=> 'Ϸ keyword Ʊ',
	'mainpart'	=> '׻, ʤɤ. ׻ݤϡ--- Abstract:פ, ܸ׻ݤϡ--- Abstract-ja:פ,  --- Note-ja:᡼륢ɥ쥹פǵϤ. <p><p>--- Abstract:<p>Abstract is here.<br>..................................<p>--- Abstract-ja:<p>ܸ׻ݤϤ<br>..................................<p>--- Note-ja: shosuke@gfd-dennou.org<p>˥<br>..................................<p>--- Note-ja: takepiro@gfd-dennou.org<p>̤οͤϤʶ³<br>..................................<p>',
 );
 %FIELDDEFAULT = (
	'address'	=> '',
	'author'	=> '',
	'author-ja'	=> '',
	'chapter'	=> '',
	'editor'	=> '',
	'editor-ja'	=> '',
	'journal'	=> '',
	'month'		=> '',
	'number'	=> '',
	'pages'		=> '',
	'publisher'	=> '',
	'series'	=> '',
	'title'		=> '',
	'title-ja'	=> '',
	'volume'	=> '',
	'year'		=> '',
	'url'	        => '',
	'remark'	=> '',
	'copyholder'	=> '',
	'history'	=> '',
	'id'	        => '',
	'keyword'	=> '',
	'keyword-ja'	=> '',
	'mainpart'	=> "--- Abstract:\n\n--- Abstract-ja:\n\n--- Note-ja:\n",
 );
}

    #
    # ƥեɤƤå. 
    # ˡ : $content=checkFieldContent($field,$content);
    # 
sub checkFieldContent {
    require 'jcode.pl';
    local($field,$content)=@_;

    if ( $field eq 'pages' ) {
	&warn("pages has no number. Are you sure?")
		if ($content ne '' && $content !~ /[0-9]/);
    }

    if ( $field eq 'author' ) {
	&warn("author should begin in uppercase letter.")
		if ($content =~ /^[a-z]/);
	&warn("author should begin in A-Za-z. ($content)")
		unless ($content =~ /^[A-Za-z]/);
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }
    if ( $field eq 'author-ja' ) {
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }

    if ( $field eq 'editor' ) {
	&warn("editor should begin in uppercase letter.")
		if ($content =~ /^[a-z]/);
	&warn("editor should begin in A-Za-z. ($content)")
		unless ($content =~ /^[A-Za-z]/);
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }
    if ( $field eq 'editor-ja' ) {
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }

    if ( $field eq 'title' ) {
	#  ASCII Ƥ褤⤦äȼ嵤
	# ե٥åȤ1ʸߤʤȷٹ𤹤
	&warn("title has no letter. Are you sure?")
		if ($content !~ /[A-Za-z]/);
    }

    if ( $field eq 'year' ) {
	$content =~ s/\s+//g;
	if ($content =~ /([^0-9x]+)/) {
		local($bad) = $1;
		$content =~ tr/0-9/x/c;
		&warn("year has bad character '$bad' --- converted to 'x'.");
	}
    }

    if ( $field eq 'copyholder' ) {
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }

    if ( $field eq 'keyword' ) {
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }

    if ( $field eq 'keyword-ja' ) {
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }

    if ( $field eq 'id' ) {
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }

    if ( $field eq 'history' ) {
	$content =~ s/[;\/]/\n/g;     # å, ߥԤ
    }

    if ( $field eq 'mainpart' ) {
	$content =~ s/\t/\n/g;        # ֤ԤѴ
    }

    if ( $field =~ /-ja$/ ) {
	&jcode'convert(*content,"euc"); # Ǹ -ja Ĥեɤ EUC 
    }
    $content;
}

######################### ʲѹ٤餺 #########################

sub cardTypeList {
	defined %CARDTYPE || cardTypeHash;
	keys %CARDTYPE;
}

sub cardTypeDescription {
	local($type) = @_;
	defined %CARDTYPE || cardTypeHash;
	$FIELDDESCRIPTION{$type};
}

sub cardTypeLongDescription {
	local($type) = @_;
	defined %CARDTYPE || cardTypeHash;
	$FIELDLONGDESCRIPTION{$type};
}

sub cardTypeFieldDefault {
	local($type) = @_;
	defined %CARDTYPE || cardTypeHash;
	$FIELDDEFAULT{$type};
}

sub requiredFields {
	local($type) = @_;
	defined %REQUIREDFIELD || cardTypeHash;
	split(' ', $REQUIREDFIELD{$type});
}

sub optionFields {
	local($type) = @_;
	defined %OPTIONFIELD || cardTypeHash;
	split(' ', $OPTIONFIELD{$type});
}

sub availableFields {
	local($type) = @_;
	defined %OPTIONFIELD || cardTypeHash;
	split(' ', "cardtype from $REQUIREDFIELD{$type} $OPTIONFIELD{$type}");
}
# japanese.pl - ܸʸѴ롼
# $Id: japanese.pl,v 1.1.1.1 2000/03/18 06:54:10 odakker Exp $
# Copyright (C) TOYODA Eizi, 1999.  All rights reserved.
#
# ץɽȤܸ EUC ȤΥ֥롼
#
# &initKC
#	Ѵʤ򤹤. ưŪ˵ư뤬
#	ưȽˤŪ˸ƤǤ褤.
#
# &open_r($filename)
#	եɤ߹ߤΤ˳, Υϥɥ֤.
#
# &readline($handle)
#	$handle  1 ɤ߼ɤѴΤ֤.
#
# $KCMethod
# 	'jcodepl':	Perl Ǽ jcode.pl ɤߤ˹Ԥ. μ.
#	'nkf':		/usr/bin ˤΤư. κ.
#	undef:		ǰ.
#
# $KCICode, $KCOCode
#	'jis'		ISO-2022-JP
#	'euc'		ܸ EUC (ǥե)
#	'sjis'		JIS X 0208-1997 ° ե沽ɽ

sub initKC {
	$KC_NKF = '/usr/bin/nkf';

	if (require 'jcode.pl') {
		$KCMethod = 'jcodepl';
	} elsif (-x $KC_NKF) {
		$KCMethod = 'nkf';
	} else {
		die "no kanji conversion method found.";
	}
	$KCIcode = undef;
}

sub open_r {
	local($filename) = @_;
	defined($KCMethod) || &initKC;
	local($path);
	if ($KCMethod eq 'nkf') {
		$path = "$KC_NKF -e \"$filename\"|"
	} else {
		$path = "<$filename";
	}
	open($filename, "$path") && $filename;
}

sub readline {
	local($handle) = @_;
	local($line, $code);
	defined($KCMethod) || &initKC;
	($line = <$handle>) || return undef;
	return $line if ($line !~ /[\033\200-\377]/);
	if ($KCMethod eq 'jcodepl') {
		($code = &jcode'getcode(*line)) && ($KCIcode = $code);
		&jcode'convert(*line, 'euc', $KCIcode);
		&jcode'h2z_euc(*line);
	}
	$line;
}

# debug code: not executed if this file follows 'exit;' line.
while ($fnam = shift) {
	$handle = &open_r($fnam);
	while ($_ = &readline($handle)) {
		print;
	}
}

